com.amazonaws.services.elastictranscoder.model

## Class CreatePipelineRequest

- java.lang.Object
- - com.amazonaws.AmazonWebServiceRequest
  - - com.amazonaws.services.elastictranscoder.model.CreatePipelineRequest

All Implemented Interfaces:
  ReadLimitInfo, Serializable, Cloneable

    public class CreatePipelineRequest
    extends AmazonWebServiceRequest
    implements Serializable, Cloneable

The `CreatePipelineRequest` structure.

See Also:
  Serialized Form

### Field Summary

### Fields inherited from class com.amazonaws.AmazonWebServiceRequest

`NOOP`

### Constructor Summary

Constructors
Constructor and Description
`CreatePipelineRequest()`

### Method Summary

All Methods Instance Methods Concrete Methods
`CreatePipelineRequest` `clone()`
`boolean` `equals(Object obj)`
`String` `getAwsKmsKeyArn()` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.
`PipelineOutputConfig` `getContentConfig()` The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.
`String` `getInputBucket()` The Amazon S3 bucket in which you saved the media files that you want to transcode.
`String` `getName()` The name of the pipeline.
`Notifications` `getNotifications()` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`String` `getOutputBucket()` The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files.
`String` `getRole()` The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.
`PipelineOutputConfig` `getThumbnailConfig()` The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.
`int` `hashCode()`
`void` `setAwsKmsKeyArn(String awsKmsKeyArn)` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.
`void` `setContentConfig(PipelineOutputConfig contentConfig)` The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.
`void` `setInputBucket(String inputBucket)` The Amazon S3 bucket in which you saved the media files that you want to transcode.
`void` `setName(String name)` The name of the pipeline.
`void` `setNotifications(Notifications notifications)` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`void` `setOutputBucket(String outputBucket)` The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files.
`void` `setRole(String role)` The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.
`void` `setThumbnailConfig(PipelineOutputConfig thumbnailConfig)` The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`CreatePipelineRequest` `withAwsKmsKeyArn(String awsKmsKeyArn)` The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

`CreatePipelineRequest`

`withContentConfig(PipelineOutputConfig contentConfig)`
The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

`CreatePipelineRequest` `withInputBucket(String inputBucket)` The Amazon S3 bucket in which you saved the media files that you want to transcode.
`CreatePipelineRequest` `withName(String name)` The name of the pipeline.
`CreatePipelineRequest` `withNotifications(Notifications notifications)` The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.
`CreatePipelineRequest` `withOutputBucket(String outputBucket)` The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files.
`CreatePipelineRequest` `withRole(String role)` The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.
`CreatePipelineRequest` `withThumbnailConfig(PipelineOutputConfig thumbnailConfig)` The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

### Methods inherited from class com.amazonaws.AmazonWebServiceRequest

`copyBaseTo, getCloneRoot, getCloneSource, getCustomQueryParameters, getCustomRequestHeaders, getGeneralProgressListener, getReadLimit, getRequestClientOptions, getRequestCredentials, getRequestCredentialsProvider, getRequestMetricCollector, getSdkClientExecutionTimeout, getSdkRequestTimeout, putCustomQueryParameter, putCustomRequestHeader, setGeneralProgressListener, setRequestCredentials, setRequestCredentialsProvider, setRequestMetricCollector, setSdkClientExecutionTimeout, setSdkRequestTimeout, withGeneralProgressListener, withRequestMetricCollector, withSdkClientExecutionTimeout, withSdkRequestTimeout`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### CreatePipelineRequest

    public CreatePipelineRequest()

### Method Detail

#### setName

    public void setName(String name)

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters.

Parameters:
  `name` - The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters.

#### getName

    public String getName()

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters.

Returns:
  The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters.

#### withName

    public CreatePipelineRequest withName(String name)

The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

Constraints: Maximum 40 characters.

Parameters:
  `name` - The name of the pipeline. We recommend that the name be unique within the AWS account, but uniqueness is not enforced.

  Constraints: Maximum 40 characters.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setInputBucket

    public void setInputBucket(String inputBucket)

The Amazon S3 bucket in which you saved the media files that you want to transcode.

Parameters:
  `inputBucket` - The Amazon S3 bucket in which you saved the media files that you want to transcode.

#### getInputBucket

    public String getInputBucket()

The Amazon S3 bucket in which you saved the media files that you want to transcode.

Returns:
  The Amazon S3 bucket in which you saved the media files that you want to transcode.

#### withInputBucket

    public CreatePipelineRequest withInputBucket(String inputBucket)

The Amazon S3 bucket in which you saved the media files that you want to transcode.

Parameters:
  `inputBucket` - The Amazon S3 bucket in which you saved the media files that you want to transcode.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setOutputBucket

    public void setOutputBucket(String outputBucket)

The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

Specify this value when all of the following are true:

- You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

- You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

- You do not want to specify the permissions that Elastic Transcoder grants to the files.

  <important>

  When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

  </important>

- You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

Parameters:
  `outputBucket` - The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

  Specify this value when all of the following are true:

  - You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

  - You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

  - You do not want to specify the permissions that Elastic Transcoder grants to the files.

    <important>

    When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

    </important>

  - You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

  If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

#### getOutputBucket

    public String getOutputBucket()

The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

Specify this value when all of the following are true:

- You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

- You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

- You do not want to specify the permissions that Elastic Transcoder grants to the files.

  <important>

  When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

  </important>

- You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

Returns:
  The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

  Specify this value when all of the following are true:

  - You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

  - You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

  - You do not want to specify the permissions that Elastic Transcoder grants to the files.

    <important>

    When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

    </important>

  - You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

  If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

#### withOutputBucket

    public CreatePipelineRequest withOutputBucket(String outputBucket)

The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

Specify this value when all of the following are true:

- You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

- You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

- You do not want to specify the permissions that Elastic Transcoder grants to the files.

  <important>

  When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

  </important>

- You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

Parameters:
  `outputBucket` - The Amazon S3 bucket in which you want Elastic Transcoder to save the transcoded files. (Use this, or use ContentConfig:Bucket plus ThumbnailConfig:Bucket.)

  Specify this value when all of the following are true:

  - You want to save transcoded files, thumbnails (if any), and playlists (if any) together in one bucket.

  - You do not want to specify the users or groups who have access to the transcoded files, thumbnails, and playlists.

  - You do not want to specify the permissions that Elastic Transcoder grants to the files.

    <important>

    When Elastic Transcoder saves files in `OutputBucket`, it grants full control over the files only to the AWS account that owns the role that is specified by `Role`.

    </important>

  - You want to associate the transcoded files and thumbnails with the Amazon S3 Standard storage class.

  If you want to save transcoded files and playlists in one bucket and thumbnails in another bucket, specify which users can access the transcoded files or the permissions the users have, or change the Amazon S3 storage class, omit `OutputBucket` and specify values for `ContentConfig` and `ThumbnailConfig` instead.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setRole

    public void setRole(String role)

The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.

Parameters:
  `role` - The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.

#### getRole

    public String getRole()

The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.

Returns:
  The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.

#### withRole

    public CreatePipelineRequest withRole(String role)

The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.

Parameters:
  `role` - The IAM Amazon Resource Name (ARN) for the role that you want Elastic Transcoder to use to create the pipeline.
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setAwsKmsKeyArn

    public void setAwsKmsKeyArn(String awsKmsKeyArn)

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Parameters:
  `awsKmsKeyArn` - The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

#### getAwsKmsKeyArn

    public String getAwsKmsKeyArn()

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Returns:
  The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

#### withAwsKmsKeyArn

    public CreatePipelineRequest withAwsKmsKeyArn(String awsKmsKeyArn)

The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Parameters:
  `awsKmsKeyArn` - The AWS Key Management Service (AWS KMS) key that you want to use with this pipeline.

  If you use either `S3` or `S3-AWS-KMS` as your `Encryption:Mode`, you don't need to provide a key with your job because a default key, known as an AWS-KMS key, is created for you automatically. You need to provide an AWS-KMS key only if you want to use a non-default AWS-KMS key, or if you are using an `Encryption:Mode` of `AES-PKCS7`, `AES-CTR`, or `AES-GCM`.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setNotifications

    public void setNotifications(Notifications notifications)

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

- Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

Parameters:
  `notifications` - The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

  - Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

#### getNotifications

    public Notifications getNotifications()

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

- Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

Returns:
  The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

  - Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

#### withNotifications

    public CreatePipelineRequest withNotifications(Notifications notifications)

The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status.

<important>

To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

</important>

- Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

- Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

- Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

Parameters:
  `notifications` - The Amazon Simple Notification Service (Amazon SNS) topic that you want to notify to report job status. <important>

  To receive notifications, you must also subscribe to the new topic in the Amazon SNS console.

  </important>

  - Progressing: The topic ARN for the Amazon Simple Notification Service (Amazon SNS) topic that you want to notify when Elastic Transcoder has started to process a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic. For more information, see Create a Topic in the Amazon Simple Notification Service Developer Guide.

  - Completed: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder has finished processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Warning: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters a warning condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

  - Error: The topic ARN for the Amazon SNS topic that you want to notify when Elastic Transcoder encounters an error condition while processing a job in this pipeline. This is the ARN that Amazon SNS returned when you created the topic.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setContentConfig

    public void setContentConfig(PipelineOutputConfig contentConfig)

The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- Grantee Type: Specify the type of value that appears in the `Grantee` object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

  - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Parameters:
  `contentConfig` - The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - Grantee Type: Specify the type of value that appears in the `Grantee` object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

#### getContentConfig

    public PipelineOutputConfig getContentConfig()

The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- Grantee Type: Specify the type of value that appears in the `Grantee` object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

  - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Returns:
  The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - Grantee Type: Specify the type of value that appears in the `Grantee` object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy` , that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

#### withContentConfig

    public CreatePipelineRequest withContentConfig(PipelineOutputConfig contentConfig)

The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

- Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- Grantee Type: Specify the type of value that appears in the `Grantee` object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

  - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Parameters:
  `contentConfig` - The optional `ContentConfig` object specifies information about the Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists: which bucket to use, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig`.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save transcoded files and playlists.

  - Permissions (Optional): The Permissions object specifies which users you want to have access to transcoded files and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - Grantee Type: Specify the type of value that appears in the `Grantee` object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution. For more information about canonical user IDs, see Access Control List (ACL) Overview in the Amazon Simple Storage Service Developer Guide. For more information about using CloudFront origin access identities to require that users use CloudFront URLs instead of Amazon S3 URLs, see Using an Origin Access Identity to Restrict Access to Your Amazon S3 Content.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to transcoded files and playlists. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the files that Elastic Transcoder adds to the bucket, including playlists and video files. Valid values include:

    - `READ`: The grantee can read the objects and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the video files and playlists that it stores in your Amazon S3 bucket.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### setThumbnailConfig

    public void setThumbnailConfig(PipelineOutputConfig thumbnailConfig)

The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- GranteeType: Specify the type of value that appears in the Grantee object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

  - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Parameters:
  `thumbnailConfig` - The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - GranteeType: Specify the type of value that appears in the Grantee object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

#### getThumbnailConfig

    public PipelineOutputConfig getThumbnailConfig()

The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- GranteeType: Specify the type of value that appears in the Grantee object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

  - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Returns:
  The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - GranteeType: Specify the type of value that appears in the Grantee object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy` , that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

#### withThumbnailConfig

    public CreatePipelineRequest withThumbnailConfig(PipelineOutputConfig thumbnailConfig)

The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

- Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

- Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

- GranteeType: Specify the type of value that appears in the Grantee object:

  - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

    <important>

    A canonical user ID is not the same as an AWS account number.

    </important>

  - Email: The value in the `Grantee` object is the registered email address of an AWS account.

  - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

- Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

- Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

  - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

  - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

- StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Parameters:
  `thumbnailConfig` - The `ThumbnailConfig` object specifies several values, including the Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files, which users you want to have access to the files, the type of access you want users to have, and the storage class that you want to assign to the files.

  If you specify values for `ContentConfig`, you must also specify values for `ThumbnailConfig` even if you don't want to create thumbnails.

  If you specify values for `ContentConfig` and `ThumbnailConfig`, omit the `OutputBucket` object.

  - Bucket: The Amazon S3 bucket in which you want Elastic Transcoder to save thumbnail files.

  - Permissions (Optional): The `Permissions` object specifies which users and/or predefined Amazon S3 groups you want to have access to thumbnail files, and the type of access you want them to have. You can grant permissions to a maximum of 30 users and/or predefined Amazon S3 groups.

  - GranteeType: Specify the type of value that appears in the Grantee object:

    - Canonical: The value in the `Grantee` object is either the canonical user ID for an AWS account or an origin access identity for an Amazon CloudFront distribution.

      <important>

      A canonical user ID is not the same as an AWS account number.

      </important>

    - Email: The value in the `Grantee` object is the registered email address of an AWS account.

    - Group: The value in the `Grantee` object is one of the following predefined Amazon S3 groups: `AllUsers`, `AuthenticatedUsers`, or `LogDelivery`.

  - Grantee: The AWS user or group that you want to have access to thumbnail files. To identify the user or group, you can specify the canonical user ID for an AWS account, an origin access identity for a CloudFront distribution, the registered email address of an AWS account, or a predefined Amazon S3 group.

  - Access: The permission that you want to give to the AWS user that you specified in `Grantee`. Permissions are granted on the thumbnail files that Elastic Transcoder adds to the bucket. Valid values include:

    - `READ`: The grantee can read the thumbnails and metadata for objects that Elastic Transcoder adds to the Amazon S3 bucket.

    - `READ_ACP`: The grantee can read the object ACL for thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `WRITE_ACP`: The grantee can write the ACL for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

    - `FULL_CONTROL`: The grantee has `READ`, `READ_ACP`, and `WRITE_ACP` permissions for the thumbnails that Elastic Transcoder adds to the Amazon S3 bucket.

  - StorageClass: The Amazon S3 storage class, `Standard` or `ReducedRedundancy`, that you want Elastic Transcoder to assign to the thumbnails that it stores in your Amazon S3 bucket.

Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public CreatePipelineRequest clone()

Overrides:
  `clone` in class `AmazonWebServiceRequest`